package com.magick.trade_service.model.parameter;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

import org.codehaus.jackson.annotate.JsonProperty;

/**
 * 
 * @author nik
 * 
 *         POJO class for representing parameters for orderClose method in
 *         OrderService interface
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "orderCloseParams")
public class OrderCloseParams {
	@JsonProperty
	@XmlElement(name = "ticket")
	private Integer ticket;
	@JsonProperty
	@XmlElement(name = "lots")
	private Double lots;
	@JsonProperty
	@XmlElement(name = "price")
	private Double price;
	@JsonProperty
	@XmlElement(name = "slippage")
	private int slippage;
	@JsonProperty
	@XmlElement(name = "color")
	private String color;
	
	public OrderCloseParams() {
	}

	public OrderCloseParams(Integer ticket, Double lots, Double price,
			int slippage, String color) {
		super();
		this.ticket = ticket;
		this.lots = lots;
		this.price = price;
		this.slippage = slippage;
		this.color = color;
	}

	public Integer getTicket() {
		return ticket;
	}

	public void setTicket(Integer ticket) {
		this.ticket = ticket;
	}

	public Double getLots() {
		return lots;
	}

	public void setLots(Double lots) {
		this.lots = lots;
	}

	public Double getPrice() {
		return price;
	}

	public void setPrice(Double price) {
		this.price = price;
	}

	public int getSlippage() {
		return slippage;
	}

	public void setSlippage(int slippage) {
		this.slippage = slippage;
	}

	public String getColor() {
		return color;
	}

	public void setColor(String color) {
		this.color = color;
	}

}
