package com.magick.trade_service.model.parameter;

import java.util.Date;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;

import org.codehaus.jackson.annotate.JsonProperty;
import org.codehaus.jackson.map.annotate.JsonDeserialize;
import org.codehaus.jackson.map.annotate.JsonSerialize;

import com.magick.trade_service.service.transformer.DateAdapter;
import com.magick.trade_service.service.transformer.JsonDateDeserializer;
import com.magick.trade_service.service.transformer.JsonDateSerializer;


/**
 * 
 * @author nik
 * 
 *         POJO class for representing parameters for orderModify method in
 *         OrderService interface
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "orderModifyParams")
public class OrderModifyParams {
	@JsonProperty
	@XmlElement(name = "ticket")
	private Integer ticket;
	@JsonProperty
	@XmlElement(name = "price")
	private Double price;
	@JsonProperty
	@XmlElement(name = "stoploss")
	private Double stoploss;
	@JsonProperty
	@XmlElement(name = "takeprofit")
	private Double takeprofit;
	@JsonProperty
	//@JsonDeserialize(using = JsonDateDeserializer.class)
	//@JsonSerialize(using = JsonDateSerializer.class)
	@XmlElement(name = "expiration", required=true)
	@XmlJavaTypeAdapter(DateAdapter.class)
	private Date expiration;
	@JsonProperty
	@XmlElement(name = "color")
	private String color;
	
	public OrderModifyParams() {
	}

	public OrderModifyParams(Integer ticket, Double price, Double stoploss,
			Double takeprofit, Date expiration, String color) {
		super();
		this.ticket = ticket;
		this.price = price;
		this.stoploss = stoploss;
		this.takeprofit = takeprofit;
		this.expiration = expiration;
		this.color = color;
	}

	public Integer getTicket() {
		return ticket;
	}

	public void setTicket(Integer ticket) {
		this.ticket = ticket;
	}

	public Double getPrice() {
		return price;
	}

	public void setPrice(Double price) {
		this.price = price;
	}

	public Double getStoploss() {
		return stoploss;
	}

	public void setStoploss(Double stoploss) {
		this.stoploss = stoploss;
	}

	public Double getTakeprofit() {
		return takeprofit;
	}

	public void setTakeprofit(Double takeprofit) {
		this.takeprofit = takeprofit;
	}

	public Date getExpiration() {
		return expiration;
	}

	public void setExpiration(Date expiration) {
		this.expiration = expiration;
	}

	public String getColor() {
		return color;
	}

	public void setColor(String color) {
		this.color = color;
	}

}
