package com.magick.trade_service.model.parameter;

import java.util.Date;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;

import org.codehaus.jackson.annotate.JsonProperty;
import org.codehaus.jackson.map.annotate.JsonDeserialize;
import org.codehaus.jackson.map.annotate.JsonSerialize;

import com.magick.trade_service.service.transformer.DateAdapter;
import com.magick.trade_service.service.transformer.JsonDateDeserializer;
import com.magick.trade_service.service.transformer.JsonDateSerializer;

/**
 * 
 * @author nik
 * 
 *         POJO class for representing parameters for orderSend method in
 *         OrderService interface
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "orderSendParams")
public class OrderSendParams {
	@JsonProperty
	@XmlElement(name = "symbol")
	private String symbol;
	@JsonProperty
	@XmlElement(name = "operationType")
	private String operationType;
	@JsonProperty
	@XmlElement(name = "volume")
	private Double volume;
	@JsonProperty
	@XmlElement(name = "price")
	private Double price;
	@JsonProperty
	@XmlElement(name = "slippage")
	private Integer slippage;
	@JsonProperty
	@XmlElement(name = "stoploss")
	private Double stoploss;
	@JsonProperty
	@XmlElement(name = "takeprofit")
	private Double takeprofit;
	@JsonProperty
	@XmlElement(name = "comment")
	private String comment;
	@JsonProperty
	@XmlElement(name = "magic")
	private Integer magic;
	@JsonProperty
	//@JsonDeserialize(using = JsonDateDeserializer.class)
	//@JsonSerialize(using = JsonDateSerializer.class)
	@XmlElement(name = "expiration")
	@XmlJavaTypeAdapter(DateAdapter.class)
	private Date expiration;
	@JsonProperty
	@XmlElement(name = "color")
	private String color;
	
	public OrderSendParams() {
	}

	public OrderSendParams(String symbol, String operationType, Double volume,
			Double price, Integer slippage, Double stoploss, Double takeprofit,
			String comment, Integer magic, Date expiration, String color) {
		this.symbol = symbol;
		this.operationType = operationType;
		this.volume = volume;
		this.price = price;
		this.slippage = slippage;
		this.stoploss = stoploss;
		this.takeprofit = takeprofit;
		this.comment = comment;
		this.magic = magic;
		this.expiration = expiration;
		this.color = color;
	}

	public String getSymbol() {
		return symbol;
	}

	public void setSymbol(String symbol) {
		this.symbol = symbol;
	}

	public Double getVolume() {
		return volume;
	}

	public void setVolume(Double volume) {
		this.volume = volume;
	}

	public Double getPrice() {
		return price;
	}

	public void setPrice(Double price) {
		this.price = price;
	}

	public Integer getSlippage() {
		return slippage;
	}

	public void setSlippage(Integer slippage) {
		this.slippage = slippage;
	}

	public Double getStoploss() {
		return stoploss;
	}

	public void setStoploss(Double stoploss) {
		this.stoploss = stoploss;
	}

	public Double getTakeprofit() {
		return takeprofit;
	}

	public void setTakeprofit(Double takeprofit) {
		this.takeprofit = takeprofit;
	}

	public String getComment() {
		return comment;
	}

	public void setComment(String comment) {
		this.comment = comment;
	}

	public Integer getMagic() {
		return magic;
	}

	public void setMagic(Integer magic) {
		this.magic = magic;
	}

	public Date getExpiration() {
		return expiration;
	}

	public void setExpiration(Date expiration) {
		this.expiration = expiration;
	}

	public String getColor() {
		return color;
	}

	public void setColor(String color) {
		this.color = color;
	}

	public String getOperationType() {
		return operationType;
	}

	public void setOperationType(String operationType) {
		this.operationType = operationType;
	}

}
