package com.magick.trade_service.service;

import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;

import com.magick.models.TradeOrder;
import com.magick.trade_service.model.parameter.OrderCloseByParams;
import com.magick.trade_service.model.parameter.OrderCloseParams;
import com.magick.trade_service.model.parameter.OrderDeleteParams;
import com.magick.trade_service.model.parameter.OrderModifyParams;
import com.magick.trade_service.model.parameter.OrderSelectParams;
import com.magick.trade_service.model.parameter.OrderSendParams;

/**
 * 
 * @author nik
 * 
 *         REST interface for OrderService.
 */
@Path("/order")
public interface OrderResource {
	@POST
	@Path("/close")
	public void orderClose(OrderCloseParams params);
	@POST
	@Path("/closeBy")
	public void orderCloseBy(OrderCloseByParams params);
	@POST
	@Path("/delete")
	public void orderDelete(OrderDeleteParams params);
	@POST
	@Path("/modify")
	public void orderModify(OrderModifyParams params);
	@POST
	@Path("/select")
	public void orderSelect(OrderSelectParams params);
	@POST
	@Produces(MediaType.APPLICATION_JSON)
	@Path("/send")
	public TradeOrder orderSend(OrderSendParams params);

}
